#!/usr/bin/perl

use DBI;

$out = `ps aux | grep $0 | grep -v 'grep ' | wc -l`;
chomp $out;

if ($out > 1) {
    warn "another $0 is already running, quit! ...";
    #exit 0;
}


my $txt = `cat /etc/fb.conf`; 
my %config = ();
for (split /\n/, $txt) {
    my ($key, $val)	= split /=/, $_, 2;
    
    if ($key) {
        $config{$key} = $val;
        warn "$key=$val\n";
    }
}

$adb = $config{dbname} if $config{dbname};
$ahost = $config{dbhost} if $config{dbhost};
$auser = $config{dbuser} if $config{dbuser};
$apass = $config{dbpass} if $config{dbpass};
$entries = $config{maxentries} || 60;
my $dbh = '';
&connect_db();

sub connect_db() {
	if ($config{dbtype} eq 'sqlite') {
    $dbh = DBI->connect("dbi:SQLite:dbname=/var/www/fusionpbx/secure/fusionpbx.db","","");
	} elsif($config{dbtype} eq 'pg') {
		$dbh = DBI->connect("DBI:Pg:database=$adb;host=$ahost", "$auser", "$apass", {RaiseError => 0, AutoCommit => 1});
	} else {
		$dbh = DBI->connect("DBI:mysql:database=$adb;host=$ahost", "$auser", "$apass", {RaiseError => 0, AutoCommit => 1});
		
	}

	if (!$dbh) {
			print j({error => '1', 'message' => 'internal error: fail to login db', 'actionid' => $query{actionid}});
			exit 0;
	}
}


$output = `fs_cli -rx "show calls count"`;

($count) = $output =~ /(\d+) total\./s;

$dbh->prepare("insert into v_active_calls (counts) values ('$count')")->execute;

$sth = $dbh->prepare("select max(id) maxid from v_active_calls");
$sth->execute();

$row = $sth->fetchrow_hashref;
$maxid = $row->{maxid} || 0;
print "maxid: $maxid\n";

if ($maxid > 0 && (($maxid % $entries) == 0)) {
	print "delete from v_active_calls where id < $maxid-$entries";
	$dbh->prepare("delete from v_active_calls where id < $maxid-$entries")->execute();
}


print "Done!\n";
